
require 'active_support/concern'

module ActsAsLiving::ActsAsLiving
  extend ActiveSupport::Concern

  class_methods do
    def acts_as_living(keys, phases: [], lock_on: [], death: :cancelled, spread: 1)
      @stage_keys     = keys
      @phases         = phases
      @locked_stages  = lock_on
      @death          = death
      @spread         = spread

      run_definers
    end

    def run_definers
      # needs to be imported first
      ActsAsLiving::MethodsDefiner.call(self)
      ActsAsLiving::EnumDefiner.call(self)
      ActsAsLiving::ScopesDefiner.call(self)
      # ActsAsLiving::ValidationsDefiner.call(self)
    end
  end
end
