# frozen_string_literal: true

module ActsAsLiving::EnumDefiner
  def self.call(klass)
    klass.class_eval do
      extend ClassMethods

      enum stage: stages_enum
    end
  end

  module ClassMethods
    def stages_enum
      stages = @stage_keys.map.with_index(&method(:to_enum_map)).to_h
      stages.merge(@death => @spread * -1)
    end

    def to_enum_map(stage, index)
      [stage, index * @spread]
    end
  end
end
