module ActsAsLiving::ScopesDefiner
  def self.call(klass)
    klass.class_eval do
      stage_keys.each do |stage|
        scope "past_#{stage}", -> { where('stage >= ?', stages_enum[stage]) }
        scope "pre_#{stage}", -> { where('stage < ?', stages_enum[stage]) }
      end

      scope :cancelled, -> { where('stage < 0') }

      phases.each do |phase, phase_stages|
        scope phase, lambda {
          phase_stages_integers = phase_stages.map { |stage| stages_enum[stage] }
          where(stage: phase_stages_integers)
        }
      end
    end
  end
end
